define scout_sonar_shifted ranger
(
  scount 16 # the number of transducers

  # define the pose of each transducer [xpos ypos heading]
  spose[0] [0.190 0.000 0.0 ]
  spose[1] [0.176 0.073 22.5 ]
  spose[2] [0.134 0.134 45.0 ]
  spose[3] [0.073 0.176 67.5 ]
  spose[4] [-0.000 0.190 90.0 ]
  spose[5] [-0.073 0.176 112.5 ]
  spose[6] [-0.134 0.134 135.0 ]
  spose[7] [-0.176 0.073 157.5 ]
  spose[8] [-0.190 -0.000 180.0 ]
  spose[9] [-0.176 -0.073 202.5 ]
  spose[10] [-0.134 -0.134 225.0 ]
  spose[11] [-0.073 -0.176 247.5 ]
  spose[12] [0.000 -0.190 270.0 ]
  spose[13] [0.073 -0.176 292.5 ]
  spose[14] [0.134 -0.134 315.0 ]
  spose[15] [0.176 -0.073 337.5 ]
		
  # define the field of view of each transducer [range_min range_max view_angle]
  sview [0 5.0 15]

  # define the size of each transducer [xsize ysize] in meters
  ssize [0.01 0.05]
)

define scout_sonar ranger
(
  scount 16 # the number of transducers

  # define the pose of each transducer [xpos ypos heading]
spose[0] [-0.000 0.190 90.0 ]
spose[1] [0.073 0.176 67.5 ]
spose[2] [0.134 0.134 45.0 ]
spose[3] [0.176 0.073 22.5 ]
spose[4] [0.190 0.000 0.0 ]
spose[5] [0.176 -0.073 -22.5 ]
spose[6] [0.134 -0.134 -45.0 ]
spose[7] [0.073 -0.176 -67.5 ]
spose[8] [0.000 -0.190 -90.0 ]
spose[9] [-0.073 -0.176 -112.5 ]
spose[10] [-0.134 -0.134 -135.0 ]
spose[11] [-0.176 -0.073 -157.5 ]
spose[12] [-0.190 -0.000 -180.0 ]
spose[13] [-0.176 0.073 157.5 ]
spose[14] [-0.134 0.134 135.0 ]
spose[15] [-0.073 0.176 112.5 ]
		
  # define the field of view of each transducer [range_min range_max view_angle]
  sview [0 5.0 15]

  # define the size of each transducer [xsize ysize] in meters
  ssize [0.01 0.05]
)


define scout_base position 
(
  color "red"			# Default color.
  drive "diff"		 	# Differential steering model.
  gui_nose 1                  	# Draw a nose on the robot so we can see which way it points
  obstacle_return 1           	# Can hit things.
  laser_return 1                 # reflects laser beams
  ranger_return 1             	# reflects sonar beams
  blobfinder_return 1         	# Seen by blobfinders  
  fiducial_return 1           	# Seen as "1" fiducial finders

  localization "gps"         	  
  localization_origin [0 0 0 0] 	# Start odometry at (0, 0, 0).

  # alternative odometric localization with simple error model
  # localization "odom"         		# Change to "gps" to have impossibly perfect, global odometry
  #  odom_error [ 0.05 0.05 0.1 ]   	# Odometry error or slip in X, Y and Theta
                                   	# (Uniform random distribution)   
)

define scout_base_no_sonar scout_base
(
  # actual size
  size [0.38 0.38 0.22] # sizes from MobileRobots' web site

  # the pioneer's center of rotation is offset from its center of area
  origin [-0.04 0 0 0]

  # draw a nose on the robot so we can see which way it points
  gui_nose 1

  # estimated mass in KG
  mass 23.0 
  # differential steering model
  drive "diff"
 )


define scout_base_with_sonar scout_base_no_sonar
(
  # use the sonar array defined above with a small vertical offset to
  # drop the sensors into the robot body
  scout_sonar( pose [0 0 -0.03 0] ) 
)

define scout_robot scout_base_with_sonar
(  
  # simplified Body shape:
  block( 
    points 16
    point[0] [0.186 0.037]
    point[1] [0.158 0.106]
    point[2] [0.106 0.158]
    point[3] [0.037 0.186]
    point[4] [-0.037 0.186]
    point[5] [-0.106 0.158]
    point[6] [-0.158 0.106]
    point[7] [-0.186 0.037]
    point[8] [-0.186 -0.037]
    point[9] [-0.158 -0.106]
    point[10] [-0.106 -0.158]
    point[11] [-0.037 -0.186]
    point[12] [0.037 -0.186]
    point[13] [0.106 -0.158]
    point[14] [0.158 -0.106]
    point[15] [0.186 -0.037]
    z [0 0.22]
  )
)

